//==================================================================
//Trubetskoy Alex,  April 2004
//==================================================================

#include "calcexpr.h"

double CalcExpr::executeOp(Lxm op, double x) {
   Lxm resLxm;
   resLxm.type = "n";
   double oprnd1, oprnd2, res = 0;

   Lxm lxm2 = (Lxm)stack.top();
   stack.pop();
   if(lxm2.type == "x") oprnd2 = x;
   else oprnd2 = lxm2.num;

   if(op.op == 'f') {
      if(op.type == "sin") res = sin(oprnd2);
      else
      if(op.type == "cos") res = cos(oprnd2);
      else
      if(op.type == "ln") {
         if(oprnd2 > 0) res = log(oprnd2);
         else {res = 0; valid = false;}
      }
      else
      if(op.type == "sqrt") {
         if(oprnd2 >= 0) res = sqrt(oprnd2);
         else {res = 0; valid = false;}
      }
      resLxm.num = res;
   }
   else {
      Lxm lxm1 = (Lxm)stack.top();
      stack.pop();
      if(lxm1.type == "x") oprnd1 = x;
      else oprnd1 = lxm1.num;

      switch (op.op) {
         case '+': res = oprnd1 + oprnd2; break;
         case '-': res = oprnd1 - oprnd2; break;
         case '*': res = oprnd1 * oprnd2; break;
         case '/': {
            if(oprnd2 != 0) res = oprnd1 / oprnd2;
            else {res = 0; valid = false;}
            break;
         }
      }
      resLxm.num = res;
   }
   stack.push(resLxm);
   return res;
}

Lxm CalcExpr::executeExpr(vector<Lxm> lxms, double x) {
   Lxm curLxm;
   iLxm = 0;
   valid = true;
   while(iLxm < lxms.size()) {
      curLxm = (Lxm)lxms[iLxm++];
      if(isOperand(curLxm))
         stack.push(curLxm);
      else
      if(isOperator(curLxm))
         executeOp(curLxm, x);
   }
   curLxm = (Lxm)stack.top();
   stack.pop();
   if(lxms.size() == 1 && curLxm.type == "x")
      curLxm.num = x;
   if(!valid) curLxm.type = "invalid";
   else curLxm.type = "valid";
   return curLxm;
} 