//==================================================================
//Trubetskoy Alex,  March 2004
//==================================================================

#include "ppn.h"

Lxm Ppn::getNxtLxm() {
   Lxm lxm;
   AnsiString curStr;
   static bool wasNum = false;

   if(curc >= 'a' && curc <= 'z') {
      if(wasNum) {
         wasNum = false;
         throw GraphException("Syntax error! 1");
      }
      while(curc>='a' && curc<='z') {
         curStr += curc;
         nxtChar();
         if(curStr == "sin" || curStr == "cos"
             || curStr == "ln" || curStr == "sqrt") {
            lxm.type = curStr;
            lxm.op = 'f';
            break;
         }
      }
      if(curStr.Length() == 1 && curStr == "x") {
         lxm.type = "x";
      }
      else {
         if(lxm.op != 'f')
            throw GraphException("Syntax error! 2");
      }
   }
   else
   if((curc >= '0' && curc <= '9') || curc == '.') {
      AnsiString num;
      num += curc;
      nxtChar();
      while((curc>='0' && curc<='9') || curc=='.') {
         num += curc;
         nxtChar();
      }
      lxm.type = "n";
      lxm.num = num.ToDouble();
      wasNum = true;
   }
   else {
      wasNum = false;
      if(curc=='(') {
         lxm.type = "ob";        //opening bracket
         ++countBr;
         nxtChar();
      }
      else
      if(curc==')') {
         lxm.type = "cb";        //closing bracket
         --countBr;
         nxtChar();
      }
      else
      if(curc=='+' || curc=='-' || curc=='*' || curc=='/') {
         lxm.type = "op";        //operation
         lxm.op = curc;
         nxtChar();
      }
      else
      if(curc == '!') lxm.op = ' ';  //end of input string
      else
         throw GraphException("Syntax error! 3");
   }
   curLxm = lxm;
   return lxm;
}

char Ppn::nxtChar() {
   if(iin < (inStr.Length()+1)) {
      curc = inStr[iin++];
   }
   else curc = '!';
   return curc;
}

void Ppn::P() {
   try {
      getNxtLxm();
      if(curLxm.type == "op")
         throw GraphException("Syntax error! 4");
      E();
   }
   catch(GraphException e) {throw e;}
}

void Ppn::E() {
   try {
      T();
      while(curLxm.op == '+' || curLxm.op == '-') {
         Lxm temp = curLxm;
         getNxtLxm();
         T();
         outLxms.push_back(temp);
      }
   }
   catch(GraphException e) {throw e;}
}

void Ppn::T() {
   try {
      F();
      while(curLxm.op == '*' || curLxm.op == '/') {
         Lxm temp = curLxm;
         getNxtLxm();
         F();
         outLxms.push_back(temp);
      }
   }
   catch(GraphException e) {throw e;}
}

void Ppn::F() {
   try {
      if(curLxm.op != 'f') {
         M();
      }
      while(curLxm.op == 'f') {
         Lxm temp = curLxm;
         getNxtLxm();
         M();
         outLxms.push_back(temp);
      }
   }
   catch(GraphException e) {throw e;}
}

void Ppn::M() {
   try {
      if(curLxm.type == "ob") {
         getNxtLxm();
         E();
         if(curLxm.type != "cb")
            throw GraphException("Syntax error! 5");
         else getNxtLxm();
      }
      else
      if(curLxm.type == "x" || curLxm.type == "n") {
         outLxms.push_back(curLxm);
         getNxtLxm();
      }
      else
         throw GraphException("Syntax error! 6");
   }
   catch(GraphException e) {throw e;}
}

vector<Lxm> Ppn::convert() {
   iin = 1;
   countBr = 0;
   nxtChar();
   try {
      P();
      if(iin != (inStr.Length()+1) || countBr != 0)
         throw GraphException("Syntax error! 7");
      return outLxms;
   }
   catch(GraphException e) {throw e;}
}