//==================================================================
//Trubetskoy Alex,  April 2004
//==================================================================

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Main.h"
#include "CalcExpr.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   this->Parent = MainForm;
   scale = 16;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   //set the form's size
   this->Top = 50;
   this->Left = 10;
   this->Width = MainForm->Width - 25;
   this->Height = MainForm->Height - 105;

   //paint axes
   this->Canvas->Pen->Color = clBlack;
   this->Canvas->Pen->Width = 3;
   //horizontal axis
   this->Canvas->MoveTo(0, Height/2);
   this->Canvas->LineTo(Width, Height/2);
   //vertical axis
   this->Canvas->MoveTo(Width/2, 0);
   this->Canvas->LineTo(Width/2, Height);

   if(funcs.size() > 0) {
      for(unsigned int i = 0; i<funcs.size(); ++i) {
         paintGraph(funcs[i]);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   this->Invalidate();
}
//---------------------------------------------------------------------------
void TForm1::paintGraph(AnsiString s)
{
   try {
      bool was_f = false;
      if(s.Length() == 0) return;

      //convert to ppn
      Ppn* ppn = new Ppn(s);
      vector<Lxm> lxms = ppn->convert();
      for(unsigned int i = 0; i<funcs.size(); ++i)
         if(funcs[i] == s) {
            was_f = true;
            break;
         }
      if(!was_f)
         funcs.push_back(s);    //store the expression for repainting
                                //the window

      //calculate and draw the graph
      CalcExpr cexpr;
      float prevX = 0, prevY = 0;        //previous coordinates
      float x, y = 0;                    //current coordinates
      bool paint = true;
      Canvas->Pen->Color = clBlack;

      for(float i = -100; i<100; ++i) {
         Lxm res = cexpr.executeExpr(lxms, i);
         x = i * scale + Width/2;
         y = (Height/2) - (float)res.num * scale;
         if(res.type == "valid" && i > -100) {
            if(paint) {
               Canvas->MoveTo(prevX, prevY);
               Canvas->LineTo(x, y);
            }
            paint = true;
         }
         else paint = false;
         prevX = x;
         prevY = y;
      } 
   }
   catch(GraphException exc) {
      ShowMessage(exc.mess);
   }
}
//---------------------------------------------------------------------------
void TForm1::clearFuncs()
{
   //delete all graphs
   funcs.clear();
   this->Invalidate();
}
//---------------------------------------------------------------------------
void TForm1::incScale()
{
   //increase scale
   if(scale < 36)
      scale += 10;
   this->Invalidate();
}
//---------------------------------------------------------------------------
void TForm1::decScale()
{
   //decrease scale
   if(scale > 6)
      scale -= 10;
   this->Invalidate();
}
//---------------------------------------------------------------------------
